const interfaceOfClass = (Klass) => {
    /**
     * Get properties of a class
     * @see https://stackoverflow.com/a/40637896/1123955
     */
    const instance = new Klass();
    const instanceProperties = Object.getOwnPropertyNames(instance);
    return () => (target) => {
        const prototypeProperties = Object
            .getOwnPropertyNames(Klass.prototype);
        // console.info('properties', prototypeProperties)
        return [
            ...instanceProperties,
            ...prototypeProperties,
        ].every(prop => prop in target);
    };
};
export { interfaceOfClass };
//# sourceMappingURL=interface-of-class.js.map